<?php
namespace Teknisa\SM\Factory;

use Doctrine\ORM\EntityManager;

class Sm00002000ModeloPropostaComposicaoFactory
{
    
    protected $connection;
    
    public function __construct(EntityManager $entityManager) {
        
        $this->connection = $entityManager->getConnection();
    }
    
    /**
     * A função "validaCompProposta" verifica se a composição 
     * que está sendo relacionada já está relacionada ao modelo.
     */
    
    public function validaCompProposta($params){
        
        $queryValidaComposicaoProp = "SELECT NRCOMPSERVICO
                                    FROM FCT_RELORCAMODCOMPOSICAO
                                   WHERE NRCOMPSERVICO IN (".$params['NRCOMPSERVICO'].")
                                     AND NRORCAMENTOMODELO = :NRORCAMENTOMODELO
                                     AND NRORG = :NRORG";

        unset($params['NRCOMPSERVICO']);
        $std = $this->connection->prepare($queryValidaComposicaoProp);
        $std->execute($params);
        $returnValidaComposicaoProp = $std->fetchAll();
        return $returnValidaComposicaoProp;
    }
    
    public function excluirEmCascata($params) {
        $sql = "DELETE FROM FCT_RELORCAMODCOMPOSICAO
                 WHERE NRORG             = :NRORG
                   AND NRORCAMENTOMODELO = :NRORCAMENTOMODELO
                   AND NRCOMPSERVICO     IN (SELECT REL.NRCOMPSERVICO
                                               FROM FCT_RELORCAMODCOMPOSICAO REL
                                               LEFT JOIN FCT_COMPSERVICO COMP
                                                 ON REL.NRCOMPSERVICO = COMP.NRCOMPSERVICO
                                                AND REL.NRORG         = COMP.NRORG
                                              WHERE REL.NRORG                  = :NRORG
                                                AND REL.NRORCAMENTOMODELO      = :NRORCAMENTOMODELO
                                              START WITH REL.NRCOMPSERVICO     = :NRCOMPSERVICO
                                            CONNECT BY PRIOR REL.NRCOMPSERVICO = COMP.NRCOMPSERVICOPAI)";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
}

?>